diff --git a/src/main/java/net/minecraft/core/net/command/helpers/BlockInput.java b/src/main/java/net/minecraft/core/net/command/helpers/BlockInput.java
new file mode 100644
index 000000000..f1ef4e5ec
--- /dev/null
+++ b/src/main/java/net/minecraft/core/net/command/helpers/BlockInput.java
@@ -0,0 +1,34 @@
+package net.minecraft.core.net.command.helpers;
+
+import com.mojang.nbt.CompoundTag;
+import net.minecraft.core.block.Block;
+import org.jetbrains.annotations.Nullable;
+
+public class BlockInput {
+    @Nullable
+    private final Block block;
+    private final int metadata;
+    private final CompoundTag tag;
+
+    public BlockInput(@Nullable Block block, int metadata, CompoundTag tag) {
+        this.block = block;
+        this.metadata = metadata;
+        this.tag = tag;
+    }
+
+    public @Nullable Block getBlock() {
+        return this.block;
+    }
+
+    public int getBlockId() {
+        return this.block == null ? 0 : this.block.id;
+    }
+
+    public int getMetadata() {
+        return this.metadata;
+    }
+
+    public CompoundTag getTag() {
+        return this.tag;
+    }
+}
\ No newline at end of file
diff --git a/src/main/java/net/minecraft/core/net/command/helpers/ClonedBlock.java b/src/main/java/net/minecraft/core/net/command/helpers/ClonedBlock.java
new file mode 100644
index 000000000..969189c34
--- /dev/null
+++ b/src/main/java/net/minecraft/core/net/command/helpers/ClonedBlock.java
@@ -0,0 +1,35 @@
+package net.minecraft.core.net.command.helpers;
+
+import net.minecraft.core.block.Block;
+import net.minecraft.core.block.entity.BlockEntity;
+import org.jetbrains.annotations.Nullable;
+
+public class ClonedBlock {
+    @Nullable
+    private final Block block;
+    private final int metadata;
+    @Nullable
+    private final BlockEntity blockEntity;
+
+    public ClonedBlock(@Nullable Block block, int metadata, @Nullable BlockEntity blockEntity) {
+        this.block = block;
+        this.metadata = metadata;
+        this.blockEntity = blockEntity;
+    }
+
+    public @Nullable Block getBlock() {
+        return this.block;
+    }
+
+    public int getBlockId() {
+        return this.block == null ? 0 : this.block.id;
+    }
+
+    public int getMetadata() {
+        return this.metadata;
+    }
+
+    public BlockEntity getBlockEntity() {
+        return this.blockEntity;
+    }
+}
\ No newline at end of file
diff --git a/src/main/java/net/minecraft/core/net/command/helpers/Coordinates2D.java b/src/main/java/net/minecraft/core/net/command/helpers/Coordinates2D.java
new file mode 100644
index 000000000..f435adaea
--- /dev/null
+++ b/src/main/java/net/minecraft/core/net/command/helpers/Coordinates2D.java
@@ -0,0 +1,66 @@
+package net.minecraft.core.net.command.helpers;
+
+import com.mojang.brigadier.exceptions.CommandSyntaxException;
+import net.minecraft.core.util.helper.MathHelper;
+import net.minecraft.core.util.phys.Vec3;
+import net.minecraft.core.net.command.CommandSource;
+import net.minecraft.core.net.command.exceptions.CommandExceptions;
+import org.jetbrains.annotations.Nullable;
+
+public class Coordinates2D {
+    private final IntegerCoordinate x;
+    private final IntegerCoordinate z;
+
+    public Coordinates2D(IntegerCoordinate x, IntegerCoordinate z) {
+        this.x = x;
+        this.z = z;
+    }
+
+    public Coordinates2D(int x, int z) {
+        this(new IntegerCoordinate(false, x), new IntegerCoordinate(false, z));
+    }
+
+    public int getX(@Nullable Integer sourceX) throws CommandSyntaxException {
+        return this.x.get(sourceX == null ? null : MathHelper.floor((double)sourceX / 16.0));
+    }
+
+    public int getZ(@Nullable Integer sourceZ) throws CommandSyntaxException {
+        return this.z.get(sourceZ == null ? null : MathHelper.floor((double)sourceZ / 16.0));
+    }
+
+    public int getX(@Nullable Double sourceX) throws CommandSyntaxException {
+        return this.x.get(sourceX == null ? null : MathHelper.floor(sourceX / 16.0));
+    }
+
+    public int getZ(@Nullable Double sourceZ) throws CommandSyntaxException {
+        return this.z.get(sourceZ == null ? null : MathHelper.floor(sourceZ / 16.0));
+    }
+
+    public int getX(CommandSource source) throws CommandSyntaxException {
+        Vec3 sourceCoordinates = source.getCoordinates(true);
+        if (sourceCoordinates == null) {
+            if (!this.x.isRelative()) {
+                return this.x.get(0);
+            } else {
+                throw CommandExceptions.notInWorld().create();
+            }
+        }
+        return this.x.get(MathHelper.floor(sourceCoordinates.x / 16.0));
+    }
+
+    public int getZ(CommandSource source) throws CommandSyntaxException {
+        Vec3 sourceCoordinates = source.getCoordinates(true);
+        if (sourceCoordinates == null) {
+            if (!this.z.isRelative()) {
+                return this.z.get(0);
+            } else {
+                throw CommandExceptions.notInWorld().create();
+            }
+        }
+        return this.z.get(MathHelper.floor(sourceCoordinates.z / 16.0));
+    }
+
+    public boolean hasRelativeCoordinate() {
+        return this.x.isRelative() || this.z.isRelative();
+    }
+}
diff --git a/src/main/java/net/minecraft/core/net/command/helpers/DoubleCoordinate.java b/src/main/java/net/minecraft/core/net/command/helpers/DoubleCoordinate.java
new file mode 100644
index 000000000..d5559c6cd
--- /dev/null
+++ b/src/main/java/net/minecraft/core/net/command/helpers/DoubleCoordinate.java
@@ -0,0 +1,50 @@
+package net.minecraft.core.net.command.helpers;
+
+import com.mojang.brigadier.StringReader;
+import com.mojang.brigadier.exceptions.CommandSyntaxException;
+import net.minecraft.core.net.command.exceptions.CommandExceptions;
+
+public class DoubleCoordinate {
+    private final boolean isRelative;
+    private final double coordinate;
+
+    public DoubleCoordinate(boolean isRelative, double coordinate) {
+        this.isRelative = isRelative;
+        this.coordinate = coordinate;
+    }
+
+    public double get(Double sourceCoordinate) throws CommandSyntaxException {
+        if (this.isRelative) {
+            if (sourceCoordinate != null) {
+                return sourceCoordinate + this.coordinate;
+            } else {
+                throw CommandExceptions.notInWorld().create();
+            }
+        }
+
+        return this.coordinate;
+    }
+
+    public static DoubleCoordinate parse(StringReader reader) throws CommandSyntaxException {
+        if (!reader.canRead()) throw CommandExceptions.incomplete().createWithContext(reader);
+
+        if (reader.peek() == '~') {
+            reader.skip();
+            if (reader.canRead() && reader.peek() != ' ') {
+                double coordinate = reader.readDouble();
+                return new DoubleCoordinate(true, coordinate);
+            } else {
+                return new DoubleCoordinate(true, 0.0);
+            }
+        } else if (reader.peek() != ' ') {
+            double coordinate = reader.readDouble();
+            return new DoubleCoordinate(false, coordinate);
+        }
+
+        throw CommandSyntaxException.BUILT_IN_EXCEPTIONS.readerExpectedDouble().createWithContext(reader);
+    }
+
+    public boolean isRelative() {
+        return this.isRelative;
+    }
+}
diff --git a/src/main/java/net/minecraft/core/net/command/helpers/DoubleCoordinates.java b/src/main/java/net/minecraft/core/net/command/helpers/DoubleCoordinates.java
new file mode 100644
index 000000000..3e7ef40a5
--- /dev/null
+++ b/src/main/java/net/minecraft/core/net/command/helpers/DoubleCoordinates.java
@@ -0,0 +1,66 @@
+package net.minecraft.core.net.command.helpers;
+
+import com.mojang.brigadier.exceptions.CommandSyntaxException;
+import net.minecraft.core.net.command.CommandSource;
+import net.minecraft.core.net.command.exceptions.CommandExceptions;
+
+public class DoubleCoordinates {
+    private final DoubleCoordinate x;
+    private final DoubleCoordinate y;
+    private final DoubleCoordinate z;
+
+    public DoubleCoordinates(DoubleCoordinate x, DoubleCoordinate y, DoubleCoordinate z) {
+        this.x = x;
+        this.y = y;
+        this.z = z;
+    }
+
+    public double getX(double sourceX) throws CommandSyntaxException {
+        return this.x.get(sourceX);
+    }
+
+    public double getY(double sourceY) throws CommandSyntaxException {
+        return this.y.get(sourceY);
+    }
+
+    public double getZ(double sourceZ) throws CommandSyntaxException {
+        return this.z.get(sourceZ);
+    }
+
+    public double getX(CommandSource source) throws CommandSyntaxException {
+        if (source.getCoordinates(false) == null) {
+            if (!this.x.isRelative()) {
+                return this.x.get(0.0);
+            } else {
+                throw CommandExceptions.notInWorld().create();
+            }
+        }
+        return this.x.get(source.getCoordinates(false).x);
+    }
+
+    public double getY(CommandSource source, boolean offsetHeight) throws CommandSyntaxException {
+        if (source.getCoordinates(offsetHeight) == null) {
+            if (!this.y.isRelative()) {
+                return this.y.get(0.0);
+            } else {
+                throw CommandExceptions.notInWorld().create();
+            }
+        }
+        return this.y.get(source.getCoordinates(offsetHeight).y);
+    }
+
+    public double getZ(CommandSource source) throws CommandSyntaxException {
+        if (source.getCoordinates(false) == null) {
+            if (!this.z.isRelative()) {
+                return this.z.get(0.0);
+            } else {
+                throw CommandExceptions.notInWorld().create();
+            }
+        }
+        return this.z.get(source.getCoordinates(false).z);
+    }
+
+    public boolean hasRelativeCoordinates() {
+        return this.x.isRelative() || this.y.isRelative() || this.z.isRelative();
+    }
+}
diff --git a/src/main/java/net/minecraft/core/net/command/helpers/EntitySelector.java b/src/main/java/net/minecraft/core/net/command/helpers/EntitySelector.java
new file mode 100644
index 000000000..f8d01420f
--- /dev/null
+++ b/src/main/java/net/minecraft/core/net/command/helpers/EntitySelector.java
@@ -0,0 +1,148 @@
+package net.minecraft.core.net.command.helpers;
+
+import com.mojang.brigadier.exceptions.CommandSyntaxException;
+import net.minecraft.core.entity.Entity;
+import net.minecraft.core.entity.player.Player;
+import net.minecraft.core.net.command.CommandSource;
+import net.minecraft.core.net.command.exceptions.CommandExceptions;
+import net.minecraft.core.util.phys.AABB;
+import net.minecraft.core.util.phys.Vec3;
+import org.jetbrains.annotations.Nullable;
+
+import java.util.ArrayList;
+import java.util.Collections;
+import java.util.List;
+import java.util.function.BiConsumer;
+import java.util.function.Function;
+import java.util.function.Predicate;
+
+public class EntitySelector {
+    public static final String ENTITY_PREFIX = "entity.";
+
+    private final int maxResults;
+    private final boolean includesEntities;
+    private final BiConsumer<Entity, List<? extends Entity>> order;
+    private final @Nullable Class<? extends Entity> limitToType;
+    private final boolean typeInverse;
+    private final boolean currentEntity;
+    private final Predicate<Entity> predicate;
+    private final @Nullable String entityId;
+    private final @Nullable String playerName;
+    private final MinMaxBounds.Doubles distance;
+    private final Function<Vec3, Vec3> position;
+    private final @Nullable AABB aABB;
+
+    public EntitySelector(int maxResults, boolean includesEntities, BiConsumer<Entity, List<? extends Entity>> order, @Nullable Class<? extends Entity> limitToType, boolean typeInverse, boolean currentEntity, Predicate<Entity> predicate, @Nullable String entityId, @Nullable String playerName, MinMaxBounds.Doubles distance, Function<Vec3, Vec3> position, @Nullable AABB aABB) {
+        this.maxResults = maxResults;
+        this.includesEntities = includesEntities;
+        this.order = order;
+        this.limitToType = limitToType;
+        this.typeInverse = typeInverse;
+        this.currentEntity = currentEntity;
+        this.predicate = predicate;
+        this.entityId = entityId;
+        this.playerName = playerName;
+        this.distance = distance;
+        this.position = position;
+        this.aABB = aABB;
+    }
+
+    public List<? extends Entity> get(CommandSource source) throws CommandSyntaxException {
+        // Entity ID/player
+        if (this.entityId != null) {
+            List<Entity> entities = new ArrayList<>();
+            for (Entity entity : source.getWorld().loadedEntityList) {
+                if ((ENTITY_PREFIX + entity.hashCode()).equals(this.entityId)) {
+                    entities.add(entity);
+                }
+            }
+            return entities.subList(0, Math.min(entities.size(), this.maxResults));
+        } else if (this.playerName != null) {
+            List<Player> players = new ArrayList<>();
+            for (Player player : source.getWorld().players) {
+                if (player.username.equals(this.playerName) || player.nickname.equals(this.playerName)) {
+                    players.add(player);
+                }
+            }
+            return players.subList(0, Math.min(players.size(), this.maxResults));
+        }
+
+        List<? extends Entity> entities;
+        if (this.currentEntity) {
+            if (source.getSender() == null) {
+                throw CommandExceptions.notInWorld().create();
+            } else {
+                entities = Collections.singletonList(source.getSender());
+            }
+        } else if (this.includesEntities) {
+            entities = source.getWorld().loadedEntityList;
+        } else {
+            entities = source.getWorld().players;
+        }
+
+        Vec3 sourceCoordinates = source.getCoordinates(true); // Should I leave it as true or should I make it false? I don't know
+        Vec3 position;
+        if (sourceCoordinates != null) {
+            position = this.position.apply(sourceCoordinates);
+            if (this.aABB != null) {
+                this.aABB.minX = this.aABB.minX + position.x;
+                this.aABB.maxX = this.aABB.maxX + position.x;
+                this.aABB.minY = this.aABB.minY + position.y;
+                this.aABB.maxY = this.aABB.maxY + position.y;
+                this.aABB.minZ = this.aABB.minZ + position.z;
+                this.aABB.maxZ = this.aABB.maxZ + position.z;
+            }
+        } else {
+            position = this.position.apply(Vec3.getTempVec3(0, 0, 0));
+        }
+
+        List<? extends Entity> temp = new ArrayList<>(entities);
+        for (Entity entity : entities) {
+            if ((limitToType != null && limitToType.isInstance(entity) == this.typeInverse)
+                || !predicate.test(entity)
+                || !this.distanceContains(entity, position.x, position.y, position.z)
+                || !aABBIntersectsWithAABB(this.aABB, entity.bb)) {
+                temp.remove(entity);
+            }
+        }
+        entities = temp;
+
+        // Sorting order
+        this.order.accept(source.getSender(), entities);
+
+        // Predicate
+        List<Entity> listAfterPredicate = new ArrayList<>();
+        for (Entity entity : entities) {
+            if (!predicate.test(entity)) continue;
+            listAfterPredicate.add(entity);
+        }
+
+        // Maximum amount of results
+        listAfterPredicate = listAfterPredicate.subList(0, Math.min(listAfterPredicate.size(), this.maxResults));
+
+        if (listAfterPredicate.isEmpty()) throw CommandExceptions.emptySelector().create();
+        return listAfterPredicate;
+    }
+
+    private boolean distanceContains(Entity entity, double x, double y, double z) {
+        if (this.distance.isAny()) return true;
+        return this.distance.contains(entity.distanceTo(x, y, z));
+    }
+
+    private static boolean aABBIntersectsWithAABB(AABB aABB1, AABB aABB2) {
+        if (aABB1 == null) return true;
+        return aABB2 != null && aABB1.intersects(aABB2);
+    }
+
+    public int getMaxResults() {
+        return this.maxResults;
+    }
+
+    public boolean includesEntities() {
+        return this.includesEntities;
+    }
+
+    public boolean isCurrentEntity() {
+        return this.currentEntity;
+    }
+}
